/*
 *	File:		___FILENAME___
 *
 *	Version:	1.0
 *
 *	Created:	___DATE___
 *
 *	Copyright:  Copyright ___YEAR___ ___ORGANIZATIONNAME___. All rights reserved.
 *
 *  Details:    This project was generated by Apple's AU Effect template as updated by Alex Kenis 8/30/15
 *
 *	Disclaimer:	IMPORTANT:  This Apple software is supplied to you by Apple Computer, Inc. ("Apple") in
 *				consideration of your agreement to the following terms, and your use, installation, modification
 *				or redistribution of this Apple software constitutes acceptance of these terms.  If you do
 *				not agree with these terms, please do not use, install, modify or redistribute this Apple
 *				software.
 *
 *				In consideration of your agreement to abide by the following terms, and subject to these terms,
 *				Apple grants you a personal, non-exclusive license, under Apple's Copyrights in this
 *				original Apple software (the "Apple Software"), to use, reproduce, modify and redistribute the
 *				Apple Software, with or without modifications, in source and/or binary forms; provided that if you
 *				redistribute the Apple Software in its entirety and without modifications, you must retain this
 *				notice and the following text and disclaimers in all such redistributions of the Apple Software.
 *				Neither the name, trademarks, service marks or logos of Apple Computer, Inc. may be used to
 *				endorse or promote products derived from the Apple Software without specific prior written
 *				permission from Apple.  Except as expressly stated in this notice, no other rights or
 *				licenses, express or implied, are granted by Apple herein, including but not limited to any
 *				patent rights that may be infringed by your derivative works or by other works in which the
 *				Apple Software may be incorporated.
 *
 *				The Apple Software is provided by Apple on an "AS IS" basis.  APPLE MAKES NO WARRANTIES, EXPRESS OR
 *				IMPLIED, INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY
 *				AND FITNESS FOR A PARTICULAR PURPOSE, REGARDING THE APPLE SOFTWARE OR ITS USE AND OPERATION ALONE
 *				OR IN COMBINATION WITH YOUR PRODUCTS.
 *
 *				IN NO EVENT SHALL APPLE BE LIABLE FOR ANY SPECIAL, INDIRECT, INCIDENTAL OR CONSEQUENTIAL
 *				DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
 *				OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) ARISING IN ANY WAY OUT OF THE USE,
 *				REPRODUCTION, MODIFICATION AND/OR DISTRIBUTION OF THE APPLE SOFTWARE, HOWEVER CAUSED AND WHETHER
 *				UNDER THEORY OF CONTRACT, TORT (INCLUDING NEGLIGENCE), STRICT LIABILITY OR OTHERWISE, EVEN
 *				IF APPLE HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *
 *
 */

#include "AUEffectBase.h"
#include "___PACKAGENAMEASIDENTIFIER___Version.h"


#ifndef _____PACKAGENAMEASIDENTIFIER____h__
#define _____PACKAGENAMEASIDENTIFIER____h__


#pragma mark _______PACKAGENAMEASIDENTIFIER___ Parameters

// parameters
static const float kDefaultValue_ParamOne = 0.5;

static CFStringRef kParameterOneName = CFSTR("Parameter One");

enum {
    kParam_One =0,
    //Add your parameters here...
    kNumberOfParameters=1
};

#pragma mark _______PACKAGENAMEASIDENTIFIER___
class ___PACKAGENAMEASIDENTIFIER___ : public AUEffectBase
{
public:
    ___PACKAGENAMEASIDENTIFIER___(AudioUnit component);
    
    virtual AUKernelBase *		NewKernel() { return new ___PACKAGENAMEASIDENTIFIER___Kernel(this); }
    
    virtual	OSStatus			GetParameterValueStrings(AudioUnitScope			inScope,
                                                         AudioUnitParameterID		inParameterID,
                                                         CFArrayRef *			outStrings);
    
    virtual	OSStatus			GetParameterInfo(AudioUnitScope			inScope,
                                                 AudioUnitParameterID	inParameterID,
                                                 AudioUnitParameterInfo	&outParameterInfo);


     // START COCOA UI::
    virtual OSStatus			GetPropertyInfo(AudioUnitPropertyID		inID,
                                                AudioUnitScope			inScope,
                                                AudioUnitElement		inElement,
                                                UInt32 &			outDataSize,
                                                Boolean	&			outWritable );
    
    virtual OSStatus			GetProperty(AudioUnitPropertyID inID,
                                            AudioUnitScope 		inScope,
                                            AudioUnitElement 		inElement,
                                            void *			outData);
    // END COCOA UI
    
    virtual	bool				SupportsTail () { return true; }
    virtual Float64				GetTailTime() {return 0.001;}
    virtual Float64				GetLatency() {return 0.0;}
    
    /*! @method Version */
    virtual OSStatus		Version() { return k___PACKAGENAMEASIDENTIFIER___Version; }
    
    
    
protected:
    class ___PACKAGENAMEASIDENTIFIER___Kernel : public AUKernelBase		// most real work happens here
    {
    public:
        ___PACKAGENAMEASIDENTIFIER___Kernel(AUEffectBase *inAudioUnit )
        : AUKernelBase(inAudioUnit)
        {
        }
        
        // *Required* overides for the process method for this effect
        // processes one channel of interleaved samples
        virtual void 		Process(	const Float32 	*inSourceP,
                                    Float32		 	*inDestP,
                                    UInt32 			inFramesToProcess,
                                    UInt32			inNumChannels,
                                    bool			&ioSilence);
        
        virtual void		Reset();
        
        //private: //state variables...
    };
};

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


#endif